"
COPYRIGHT (c) 2020 LabWare
"
"{ Package: 'stx:goodies/monticello/tonel' }"

"{ NameSpace: Smalltalk }"

TonelScanner subclass:#TonelCommentScanner
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SCM-Monticello-Tonel-Core'
!

TonelCommentScanner comment:'I scan comments.'
!

!TonelCommentScanner class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2020 LabWare

"
! !

!TonelCommentScanner methodsFor:'scanning'!

scan
    | result ch eatNext |
    
    result := String new writeStream.

    eatNext := false.
    stream next = $" ifFalse: [ TonelParseError signal: 'Can''t parse comment' ].       
    [ stream atEnd not 
        and: [ 
                (ch := stream next) ~= $" 
                or: [ eatNext := (stream peek = $") ] ] ]
    whileTrue: [ 
        result nextPut: ch.
        eatNext ifTrue: [ 
            stream skip: 1.
            eatNext := false ] ].
    
    "/self flag: #todo. "This is a hack to make my clean algoritm for bodies work also for 
    "/ comments. I need to refactor the 'eat enter' part out to use just that."
    ^ self 
        removeFrom: '"',result contents,'"' withInternalLineEndings
        enclosingStart: $" 
        end: $"

    "Modified: / 31-08-2020 / 16:26:58 / Jan Vrany <jan.vrany@labware.com>"
! !

!TonelCommentScanner class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

